import React,{Component} from 'react';
import className from 'classnames';
import {NumberPan} from '@commonComp';
import style from './index.less';
import {handleEnter} from '@utils/tools.js';
import config from '@config/index';
import $ from "jquery";
/***
 * author:zn@2018-11-19
 * 接收参数：
 * value: 默认选中的值
 * placeholder：灰显文字
 * handleSelect: 选中事件
 * show: 是否显示下拉
 *
 * ***/
class NumberDrop extends Component{
  constructor(props){
    super(props);
    this.state={
      editable:false,      //标签是否可输入
      //numEditable:true,      //数字框是否可输入
      inputed:false,
      timer:null,
      hasSelect:false       //是否点过下拉键盘
    };
    this.$span = React.createRef();
    this.$pre = React.createRef();
    this.$suf = React.createRef();
    this.isIE = navigator.appName=="Microsoft Internet Explorer" && navigator.appVersion.split(";")[1].replace(/[ ]/g,"")=="MSIE8.0";
    this.select = this.select.bind(this);
    this.numInpBlur = this.numInpBlur.bind(this);
    this.handleNumInput = this.handleNumInput.bind(this);
    this.handleNumFocus = this.handleNumFocus.bind(this);
    this.handleBlur = this.handleBlur.bind(this);
    this.changeToEdit = this.changeToEdit.bind(this);
  }
  select(text){    console.log('数字选中')     //选中键盘上数字事件
    const {handleSelect,ikey,suffix,prefix,mainSaveText} = this.props;
    this.setState({
      hasSelect:true
    });
    handleSelect&&handleSelect({ikey,text,suffix,prefix,mainSaveText});
  }
  handleNumFocus(e){    console.log('数字聚焦')   //数字框可编辑状态下聚集事件，处理是否显示下拉等
    e.stopPropagation();
    const {show,handleShow,ikey,id,patId,handleHide,value} = this.props;
    const that = this;

    //双击时不显示下拉
    const timer = setTimeout(function(){
      const {editable,timer} = that.state;
      clearTimeout(timer);//取消延时的单击事件
      if(editable){
        return;
      }
      handleShow&&handleShow({ikey,id:patId||id});
    },300);
    this.setState({
      timer
    });
  }
  numInpBlur(e){  console.log('数字失焦')      //数字框失焦，保存值到store中
    e.stopPropagation();
    this.setState({
      hasSelect:false
    });
    const val = e.target.innerText.replace(/^\s*/,'');
    const {handleSelect,ikey,suffix,prefix,mainSaveText,placeholder} = this.props;
    const text = val===placeholder?'':val;
    if(!this.isIE){
      e.target.innerText = '';
    }
    //this.$pre.current.innerText = '';
    //e.target.innerText = '';      //避免出现重复输入值
    handleSelect&&handleSelect({ikey,text,suffix,prefix,mainSaveText});
  }
  handleNumInput(){           //数字直接输入，关闭弹窗
    const {handleHide,show} = this.props;
    if(show){
      handleHide&&handleHide();
    }
    /*if(!this.$span.current.innerHTML){
      this.$span.current.innerHTML = '&nbsp;';
    }*/
    //console.log('输入：',this.$span.current.innerHTML,'32')
  }
  getClasses(){         //整个标签是否有值的状态
    const {value,hideTag,placeholder} = this.props;
    const isSelected = value&&value!=placeholder?style['selected']:style['container'];
    const noTag = hideTag?style['no-tag']:'';
    return className(isSelected,noTag);
  }
  changeToEdit(){   console.log('双击编辑')     //整个标签双击编辑状态
    const {value,id,handleDbclick,patId} = this.props;
    clearTimeout(this.state.timer);//取消延时的单击事件
    //e.preventDefault();
    if(value&&value.trim()) {//有选中值的标签才能双击编辑
      this.setState({
        editable: true
      });
      //e.target.focus();
      //双击埋点记录
      handleDbclick && handleDbclick({id:patId||id});
    }
  }
  handleBlur(e){  console.log('双击blur')   //双击编辑blur
    const {handleLabelChange,ikey,boxMark,value} = this.props;
    //if(!this.state.editable) return;
    this.setState({
      editable: false
    });
    let totalVal = e.target.innerText;
    let changeVal = this.$span.current.innerText.replace(/^\s*/,'');//数字框值-修改后;去掉前空格避免多空格叠加
    let prefix = this.$pre.current.innerText.replace(/^\s*/,''); //前缀值-修改后
    let suffix = this.$suf.current.innerText.replace(/^\s*/,''); //后缀值-修改后
    //console.log('数字框：'+changeVal,";全部："+totalVal,";前缀："+prefix+";后缀："+suffix);
    handleLabelChange && handleLabelChange({ikey,changeVal,type:boxMark,totalVal,prefix,suffix});
  }
  getSpanClass(){       //将被替换的文字选中状态显示
    const {hasSelect} = this.state;
    const cls = !hasSelect&&this.props.show?style['blued']:'';
    return cls;
  }
  componentDidMount(){
    if(this.isIE){
      $(this.$span.current).onIe8Input(function(e){
        this.handleNumInput(e)
      },this);
    }
  }
  render(){
    const {placeholder,prefix,suffix,show,value,handleHide} = this.props;
    const {numEditable,editable,hasSelect} = this.state;
    return <div className={this.getClasses()}
                onDblClick={this.changeToEdit}
                contentEditable={editable}
                onBlur={this.handleBlur}
                onkeydown={handleEnter}>
      <span ref = {this.$pre}>&nbsp;{prefix}</span>
      <span onFocus={this.handleNumFocus}
            onDblClick={this.changeToEdit}
            onBlur={this.numInpBlur}
            onInput={this.handleNumInput}
            ref = {this.$span}
            contentEditable={!editable}
            className={this.getSpanClass()}>&nbsp;{value||placeholder}</span>
      <span ref = {this.$suf}>&nbsp;{suffix}</span>
      <NumberPan handleSelect={(text)=>this.select(text)}
                 onClose={handleHide}
                 show={show} toClear={!hasSelect}/>
    </div>
  }
}

export default NumberDrop;